﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using Infragistics.Windows.Editors;
using Infragistics.Windows.DataPresenter;
using System.Data.SqlClient;
using System.Threading;
using System.Collections.Specialized;
using System.Globalization;
using Infragistics.Windows.Controls;
using Infragistics.Olap;
using Infragistics.Olap.FlatData;
using System.Collections;
using System.Reflection;


namespace xamPivotGrid
{
    /// <summary>
    /// Interaction logic for ModuleTransactionData.xaml
    /// </summary>
    public partial class ModuleTransactionData : UserControl
    {

        #region "Variables"
        
        List<String> arrValues;
        private delegate void ProgressDisplayer();
        MainWindow _mainWinObj;
        DataTable dtTranData;
        FlatDataSource flatDataSource;

        #endregion

        #region "Constructors"
        public ModuleTransactionData()
        {
            InitializeComponent();
            dtTranData = new DataTable();
            dtTranData.Columns.Add("RowID");
            dtTranData.Columns.Add("Scenario");
            dtTranData.Columns.Add("TimePeriod");
            dtTranData.Columns.Add("Category");
            dtTranData.Columns.Add("Entity");
            dtTranData.Columns.Add("Vendor");
            dtTranData.Columns.Add("Value1");
            for (int i = 0; i < 1000; i++)
            {
                DataRow dr = dtTranData.NewRow();
                dr[0] = i;
                dr[1] = "Scenario" + i;
                dr[2] = DateTime.Now;
                dr[3] = "MAIN";
                if (i < 500)
                { dr[4] = "SAS"; }
                else
                { dr[4] = "SEM"; }
                if (i < 500)
                { dr[5] = "VEN1"; }
                else
                { dr[5] = "VEN2"; }                
                dr[6] = i;

                dtTranData.Rows.Add(dr);
            }
        }
        #endregion

        #region "Properties"
        public List<String> PeriodValues
        {
            set { arrValues = value; }
        }
      
        public MainWindow MainWindow
        {
            get { return _mainWinObj; }
            set { _mainWinObj = value; }
        }

        public string ModuleName
        { get; set; }

        #endregion

        #region "Event Handlers"

        private void ctrlModuleTransactionData_Loaded(object sender, RoutedEventArgs e)
        {
            ResetPivot();
        }

        private void xamDataGrid1_CellActivating(object sender, Infragistics.Windows.DataPresenter.Events.CellActivatingEventArgs e)
        {
            e.Cell.Field.Settings.AllowEdit = false;
        }

        private void xamDataGrid1_RecordsDeleted(object sender, Infragistics.Windows.DataPresenter.Events.RecordsDeletedEventArgs e)
        {
            xamDataGrid1.ActiveRecord = null;
        }        
       
        private void btnRefresh_Click(object sender, RoutedEventArgs e)
        {
            LoadDataGrid();
        }

        private void xamDataGrid1_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            foreach (Field field in e.FieldLayout.Fields)
            {
                if ((field.DataType == typeof(string)) && (field.Name != "Account") && (field.Name != "Dim0"))
                {
                    field.Settings.FilterOperatorDefaultValue = Infragistics.Windows.Controls.ComparisonOperator.Equals;
                }
            }
        }
       

        #endregion

        #region "Methods"

        public void LoadDataGrid()
        {
            xamDataGrid1.DataSource = dtTranData.DefaultView;

            LoadPivot();
        }

        public void LoadPivot()
        {
            ResetPivot();

            DynamicTypeBuilder typeBuilder = new DynamicTypeBuilder
            {
                DynamicAssemblyName = "TransacData",
                DynamicTypeName = ModuleName + " Data"
            };

            IList<DynamicTypePropertyInfo> properties = new List<DynamicTypePropertyInfo>();
            foreach (DataColumn column in dtTranData.Columns)
            {
                DynamicTypePropertyInfo propertyInfo = new DynamicTypePropertyInfo
                {
                    PropertyName = column.ColumnName,
                    PropertyType = column.DataType
                };
                properties.Add(propertyInfo);
            }

            Type dynamicType = typeBuilder.GenerateType(properties);
            Type listType = typeof(List<>);
            Type genericListType = listType.MakeGenericType(dynamicType);
            IList list = (IList)Activator.CreateInstance(genericListType);

            foreach (DataRow dataRow in dtTranData.Rows)
            {
                object myDynamicInstance = Activator.CreateInstance(dynamicType);
                foreach (DataColumn column in dtTranData.Columns)
                {
                    PropertyInfo propertyVal = dynamicType.GetProperty(column.ColumnName);
                    if (dataRow[column] != DBNull.Value)
                    {
                        propertyVal.SetValue(myDynamicInstance, dataRow[column], null);
                    }
                }
                list.Add(myDynamicInstance);
            }

            flatDataSource = new FlatDataSource()
            {
                ItemsSource = list,
                Cube = DataSourceBase.GenerateInitialCube(ModuleName + " Data"),                 
                // if you know the names of demensions you want to be in rows and columns 
                // you can define them here
                Columns = DataSourceBase.GenerateInitialItems("[Entity].[Entity]"),
                Rows = DataSourceBase.GenerateInitialItems("[TimePeriod].[TimePeriod]"),
                Measures = DataSourceBase.GenerateInitialItems("Value1")

            };            
           
            
            foreach (DataColumn col in dtTranData.Columns)
            {
                if (col.DataType == typeof(System.String))
                {
                    HierarchyDescriptor hd = new HierarchyDescriptor();
                    hd.SourcePropertyName = col.Caption;

                    HierarchyLevelDescriptor hldAll = new HierarchyLevelDescriptor();
                    hldAll.LevelName = "All";
                    hd.LevelDescriptors.Add(hldAll);

                    HierarchyLevelDescriptor hldName = new HierarchyLevelDescriptor();
                    hldName.LevelName = col.Caption + " Name";
                    hldName.LevelExpressionPath = col.Caption;                    
                    hd.LevelDescriptors.Add(hldName);                    
                    flatDataSource.HierarchyDescriptors.Add(hd);                    
                }
            }
           
            
            pivotDataSlicer.SlicerProvider = flatDataSource;
            pivotDataSelector.DataSource = flatDataSource;
            pivotGrid.DataSource = flatDataSource;
        }

        public void ResetPivot()
        {            
            flatDataSource = null;
            pivotGrid.DataSource = null;            
            pivotDataSlicer.SlicerProvider = null;   
            pivotDataSelector.DataSource = null;
            pivotDataSelector.Visibility = System.Windows.Visibility.Hidden;
            pivotDataSelector.Visibility = System.Windows.Visibility.Visible;
            pivotDataSelector.UpdateLayout();

        }

        #endregion

    }
}
